## drumstick-dmo 2.3.1

=== CMakeLists.txt ===
# MIDI C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required(VERSION 3.14)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.12" CACHE STRING "Minimum OS X deployment version")

project( Drumstick
    VERSION 2.3.1
    LANGUAGES C CXX
    DESCRIPTION "MIDI C++ Libraries for Qt"
    HOMEPAGE_URL "https://sourceforge.net/p/drumstick/"
)

list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_admin)
include(SCMRevision)
include(CTest)
include(GNUInstallDirs)

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR}/bin)
set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/lib)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# cmake bug https://gitlab.kitware.com/cmake/cmake/issues/18396 closed in cmake 3.14
if(APPLE AND ${CMAKE_VERSION} VERSION_LESS 3.14)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
endif()

if (WIN32 AND CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8") #/source-charset:utf-8 /execution-charset:utf-8
endif()

if(UNIX AND NOT APPLE)
    if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
    endif()
    #set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
    #set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
    #set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed -Wl,--no-undefined")
endif()

add_definitions(-DVERSION=${PROJECT_VERSION})
if (DEFINED PROJECT_WC_REVISION)
    add_definitions(-DREVISION=${PROJECT_WC_REVISION})
endif()

if (UNIX)
    set(_DOCS_INIT ON)
else()
    set(_DOCS_INIT OFF)
endif()

set(_DBUS_INIT OFF)
if (UNIX AND NOT APPLE)
    set(_PULSE_INIT ON)
else ()
    set(_PULSE_INIT OFF)
endif ()

if (APPLE)
    set(_FRAMEWORKS_INIT ON)
else()
    set(_FRAMEWORKS_INIT OFF)
endif()

option(BUILD_DOCS "Build Doxygen documentation and man pages" ${_DOCS_INIT})
option(BUILD_UTILS "Build Utilities and Examples" ON)
option(BUILD_FRAMEWORKS "Build macOS style frameworks" ${_FRAMEWORKS_INIT})
option(STATIC_DRUMSTICK "Build static libraries instead of dynamic" OFF)
option(USE_DBUS "Include DBus support (required for RealtimeKit)" ${_DBUS_INIT})
option(USE_PULSEAUDIO "Build Sonivox RT backend (if PulseAudio is available)" ${_PULSE_INIT})
option(USE_FLUIDSYNTH "Build FluidSynth RT backend (if available)" ON)
option(USE_NETWORK "Build Network RT backend (if QtNetwork is available)" ON)

if(STATIC_DRUMSTICK)
    set(BUILD_SHARED_LIBS OFF)
    add_definitions(-DDRUMSTICK_STATIC)
    message(STATUS "Building static libraries")
else()
    set(BUILD_SHARED_LIBS ON)
    if (BUILD_FRAMEWORKS)
        message(STATUS "Building macOS style frameworks")
    else()
        message(STATUS "Building unix dynamic libraries")
    endif()
endif()

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    set(CMAKE_FRAMEWORK ${BUILD_FRAMEWORKS})
endif()

find_package(QT NAMES Qt6 Qt5 COMPONENTS Core REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core REQUIRED)
message(STATUS "Found Qt version = ${QT_VERSION}")

if(USE_DBUS)
    find_package(Qt${QT_VERSION_MAJOR}DBus REQUIRED)
    add_definitions(-DRTKIT_SUPPORT)
    message(STATUS "Found QtDBus version = ${Qt${QT_VERSION_MAJOR}DBus_VERSION}")
endif()

if(USE_NETWORK)
    find_package(Qt${QT_VERSION_MAJOR}Network REQUIRED)
    if(Qt${QT_VERSION_MAJOR}Network_FOUND)
        message(STATUS "Found QtNetwork version = ${Qt${QT_VERSION_MAJOR}Network_VERSION}")
    else()
        message(STATUS "Warning: QtNetwork library not available. Network RT backend won't be built.")
    endif()
endif()

find_package(PkgConfig REQUIRED)
if(PKG_CONFIG_FOUND)
	message(STATUS "Program pkg-config ${PKG_CONFIG_VERSION_STRING} found (${PKG_CONFIG_EXECUTABLE})")
else()
	message(FATAL_ERROR "Program pkg-config not found")
endif()

if(${CMAKE_SYSTEM} MATCHES "Linux")
    pkg_check_modules(ALSA REQUIRED IMPORTED_TARGET alsa>=1.0.0)
    if(ALSA_FOUND)
        message(STATUS "Found ALSA version = ${ALSA_VERSION}")
    endif()
endif()

if(UNIX AND NOT APPLE)
    if (USE_PULSEAUDIO)
        pkg_check_modules(PULSE QUIET IMPORTED_TARGET libpulse-simple)
    endif()
    if(PULSE_FOUND)
        message(STATUS "Found PulseAudio version = ${PULSE_VERSION}")
    else()
        message(STATUS "Warning: PulseAudio library not available. Sonivox RT backend won't be built.")
    endif()
endif()

if (PKG_CONFIG_FOUND)
    if (USE_FLUIDSYNTH)
        pkg_check_modules(FLUIDSYNTH QUIET IMPORTED_TARGET fluidsynth>=1.1.1)
    endif()
    if(FLUIDSYNTH_FOUND)
        message(STATUS "Found FluidSynth version = ${FLUIDSYNTH_VERSION}")
    else()
        message(STATUS "Warning: FluidSynth library not available. FluidSynth RT backend won't be built.")
    endif()
endif()

if (${CMAKE_SYSTEM} MATCHES "Darwin")
    find_package(Qt${QT_VERSION_MAJOR}Concurrent REQUIRED)
    if (Qt${QT_VERSION_MAJOR}Concurrent_FOUND)
        message(STATUS "Found Qt${QT_VERSION_MAJOR}Concurrent version = ${Qt${QT_VERSION_MAJOR}Concurrent_VERSION_STRING}")
    endif()
endif()

# CMAKE_SYSTEM_PROCESSOR is broken on Windows with MSVC
# cmake bug https://gitlab.kitware.com/cmake/cmake/-/issues/15170 still open in 2021/03
if (MSVC)
    string(TOLOWER ${MSVC_CXX_ARCHITECTURE_ID} CMAKE_SYSTEM_PROCESSOR)
endif()

message (STATUS "${PROJECT_NAME} v${PROJECT_VERSION}
    Install prefix: ${CMAKE_INSTALL_PREFIX}
    Build configuration: ${CMAKE_BUILD_TYPE}
    System: ${CMAKE_SYSTEM_NAME}
    Processor: ${CMAKE_SYSTEM_PROCESSOR}
    Qt Version: ${QT_VERSION}
    D-Bus support: ${USE_DBUS}
    Network support: ${USE_NETWORK}
    PulseAudio support: ${USE_PULSEAUDIO}
    FluidSynth support: ${USE_FLUIDSYNTH}
    Building tests: ${BUILD_TESTING}
    Building docs: ${BUILD_DOCS}
    Building utils: ${BUILD_UTILS}
    Building frameworks: ${BUILD_FRAMEWORKS}"
)

add_subdirectory(library)
if (BUILD_UTILS)
    add_subdirectory(utils)
endif()
add_subdirectory(icons)

if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

if(UNIX AND NOT APPLE)
    if (BUILD_DOCS)
        find_package(Doxygen REQUIRED dot)
        if(DOXYGEN_FOUND)
            string(REPLACE ";" " " DOXYGEN_INCLUDE_DIRS "${Qt${QT_VERSION_MAJOR}Core_INCLUDE_DIRS}")
            configure_file("${CMAKE_SOURCE_DIR}/Doxyfile.in"
                "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile" IMMEDIATE @ONLY)
            add_custom_target(doxygen
                ${DOXYGEN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile"
                WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        endif()
        add_subdirectory(doc)
    endif()
    configure_file(drumstick.spec.in drumstick.spec IMMEDIATE @ONLY)
    if(ALSA_FOUND AND PKG_CONFIG_FOUND)
        configure_file(drumstick-alsa.pc.in drumstick-alsa.pc IMMEDIATE @ONLY)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/drumstick-alsa.pc
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    endif()
    # XML mime types
    set( SHARED_MIME_INFO_MINIMUM_VERSION "0.30" )
    set( XDG_MIME_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/mime/packages" )
    find_package( SharedMimeInfo )
    if( SHARED_MIME_INFO_FOUND )
        install( FILES drumstick.xml DESTINATION ${XDG_MIME_INSTALL_DIR} )
        update_xdg_mimetypes( ${XDG_MIME_INSTALL_DIR} )
    endif()
endif()

if(PKG_CONFIG_FOUND)
    configure_file(drumstick-file.pc.in drumstick-file.pc IMMEDIATE @ONLY)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-file.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    configure_file(drumstick-rt.pc.in drumstick-rt.pc IMMEDIATE @ONLY)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-rt.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
    configure_file(drumstick-widgets.pc.in drumstick-widgets.pc IMMEDIATE @ONLY)
    install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-widgets.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
endif()

# uninstall custom target
configure_file(
    "${CMAKE_SOURCE_DIR}/cmake_admin/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)
add_custom_target( uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if(UNIX)
    # tarball target
    add_custom_target( tarball
        COMMAND mkdir -p drumstick-${PROJECT_VERSION}
        COMMAND cp -r cmake_admin drumstick-${PROJECT_VERSION}
        COMMAND cp -r library drumstick-${PROJECT_VERSION}
        COMMAND cp -r utils drumstick-${PROJECT_VERSION}
        COMMAND cp -r doc drumstick-${PROJECT_VERSION}
        COMMAND cp -r icons drumstick-${PROJECT_VERSION}
        COMMAND cp -r tests drumstick-${PROJECT_VERSION}
        COMMAND cp CMakeLists.txt AUTHORS COPYING ChangeLog NEWS TODO *.md drumstick*.in drumstick.pro drumstick.xml configure* Doxyfile.in global.pri drumstick-${PROJECT_VERSION}
        COMMAND tar -cj --exclude=.[a-z]* -f drumstick-${PROJECT_VERSION}.tar.bz2 drumstick-${PROJECT_VERSION}
        COMMAND tar -cz --exclude=.[a-z]* -f drumstick-${PROJECT_VERSION}.tar.gz  drumstick-${PROJECT_VERSION}
        COMMAND zip -qr drumstick-${PROJECT_VERSION}.zip drumstick-${PROJECT_VERSION} -x '.[a-z]*'
        COMMAND rm -rf drumstick-${PROJECT_VERSION}
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
endif()

=== doc/CMakeLists.txt ===
# MIDI Sequencer C++ Library 
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along 
# with this program; If not, see <http://www.gnu.org/licenses/>.

find_program(XSLTPROC_EXECUTABLE xsltproc)
if(XSLTPROC_EXECUTABLE)
    message(STATUS "XSLTPROC Found: ${XSLTPROC_EXECUTABLE}")
    #unset(RELEASE_DATE)
    #execute_process (
    #    COMMAND bash -c "LANG=C;date +'%B %d, %Y'"
    #    OUTPUT_VARIABLE RELEASE_DATE
    #    OUTPUT_STRIP_TRAILING_WHITESPACE
    #)
    set(RELEASE_DATE "July 29, 2021")
    configure_file(drumstick-devel.doc.txt.in
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-devel.doc.txt IMMEDIATE @ONLY)
    configure_file(drumstick-drumgrid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpmid.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml IMMEDIATE @ONLY)
    configure_file(drumstick-dumpwrk.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml IMMEDIATE @ONLY)
    configure_file(drumstick-metronome.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml IMMEDIATE @ONLY)
    configure_file(drumstick-playsmf.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml IMMEDIATE @ONLY)
    configure_file(drumstick-guiplayer.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml IMMEDIATE @ONLY)
    configure_file(drumstick-sysinfo.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml IMMEDIATE @ONLY)
    configure_file(drumstick-vpiano.xml.in 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml IMMEDIATE @ONLY)
    include(CreateManpages)
    create_manpages ( 
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-drumgrid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpmid.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-dumpwrk.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-metronome.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-playsmf.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-guiplayer.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-sysinfo.xml
        ${CMAKE_CURRENT_BINARY_DIR}/drumstick-vpiano.xml 
    )
else()
    message(STATUS "Warning: XSLTPROC NOT Found. Man pages won't be installed")
endif()

=== icons/CMakeLists.txt ===
# MIDI C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

install(FILES drumstick_16.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/16x16/apps"
    RENAME drumstick.png)

install(FILES drumstick_32.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/32x32/apps"
    RENAME drumstick.png)

install(FILES drumstick_48.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/48x48/apps"
    RENAME drumstick.png)

install(FILES drumstick_64.png 
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/64x64/apps"
    RENAME drumstick.png)

install(FILES drumstick.svgz
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/scalable/apps")

=== library/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

if(ALSA_FOUND)
    add_subdirectory(alsa)
endif()
add_subdirectory(file)
add_subdirectory(rt)
add_subdirectory(rt-backends)
add_subdirectory(widgets)
add_subdirectory(vpiano-plugin)

configure_file( drumstick-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-config.cmake
  @ONLY
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file( ${CMAKE_BINARY_DIR}/drumstick-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install( FILES
    ${CMAKE_BINARY_DIR}/drumstick-config.cmake
    ${CMAKE_BINARY_DIR}/drumstick-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== tests/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

find_package(Qt${QT_VERSION_MAJOR}Test REQUIRED)
set (CMAKE_AUTOMOC ON)
enable_testing()

if (ALSA_FOUND)
    add_subdirectory(alsaTest1)
    add_subdirectory(alsaTest2)
endif()

add_subdirectory(fileTest1)
add_subdirectory(fileTest2)
add_subdirectory(rtTest)
add_subdirectory(widgetsTest)

=== utils/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

add_subdirectory(dumpsmf)
add_subdirectory(dumpwrk)
add_subdirectory(vpiano)

if(ALSA_FOUND)
    add_subdirectory(dumpmid)
    add_subdirectory(playsmf)
    add_subdirectory(guiplayer)
    add_subdirectory(sysinfo)
    add_subdirectory(metronome)
    add_subdirectory(drumgrid)
endif()

=== library/alsa/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(drumstick-alsa_QTOBJ_SRCS
    ../include/drumstick/alsaclient.h
    ../include/drumstick/alsaevent.h
    ../include/drumstick/alsaport.h
    ../include/drumstick/alsaqueue.h
    ../include/drumstick/alsatimer.h
    ../include/drumstick/playthread.h
)

set(drumstick-alsa_HEADERS
    ../include/drumstick/alsaclient.h
    ../include/drumstick/alsaevent.h
    ../include/drumstick/alsaport.h
    ../include/drumstick/alsaqueue.h
    ../include/drumstick/alsatimer.h
    ../include/drumstick/playthread.h
    ../include/drumstick/sequencererror.h
    ../include/drumstick/subscription.h
)

set(drumstick-alsa_SRCS
    alsaclient.cpp
    alsaevent.cpp
    alsaport.cpp
    alsaqueue.cpp
    alsatimer.cpp
    playthread.cpp
    sequencererror.cpp
    subscription.cpp
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})
else()
    qt_wrap_cpp(drumstick-alsa_MOC_SRCS ${drumstick-alsa_QTOBJ_SRCS})
endif()

add_library(drumstick-alsa
    ${drumstick-alsa_MOC_SRCS}
    ${drumstick-alsa_SRCS}
    ${drumstick-alsa_HEADERS}
)

add_library(Drumstick::ALSA ALIAS drumstick-alsa)

target_include_directories(drumstick-alsa PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(drumstick-alsa PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
    PkgConfig::ALSA
)

if(USE_DBUS)
    target_link_libraries(drumstick-alsa PRIVATE
        Qt${QT_VERSION_MAJOR}::DBus
    )
endif()

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-alsa PROPERTIES
        STATIC_LIB "libdrumstick-alsa")
else()
    set_target_properties(drumstick-alsa PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME ALSA
    )
endif()

install(TARGETS drumstick-alsa
    EXPORT drumstick-alsa-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-alsa_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)
install(FILES ../include/drumstick.h
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT drumstick-alsa-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-alsa-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-alsa-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file( ${CMAKE_BINARY_DIR}/drumstick-alsa-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-alsa-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-alsa-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-alsa-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-alsa-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== library/file/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0)
    find_package(Qt6 COMPONENTS Core5Compat REQUIRED)
endif()

set(drumstick-file_QTOBJ_SRCS
    ../include/drumstick/qsmf.h
    ../include/drumstick/qwrk.h
)

set(drumstick-file_HEADERS
    ../include/drumstick/macros.h
    ../include/drumstick/qsmf.h
    ../include/drumstick/qwrk.h
)

if(BUILD_FRAMEWORKS)
    set_source_files_properties(${drumstick-file_HEADERS}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/drumstick
    )
endif()

set(drumstick-file_SRCS
    qsmf.cpp
    qwrk.cpp
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})
else()
    qt_wrap_cpp(drumstick-file_MOC_SRCS ${drumstick-file_QTOBJ_SRCS})
endif()

add_library(drumstick-file
    ${drumstick-file_MOC_SRCS}
    ${drumstick-file_SRCS} 
    ${drumstick-file_HEADERS} 
)

add_library(Drumstick::File ALIAS drumstick-file)

target_include_directories(drumstick-file PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(drumstick-file PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
)

if (QT_VERSION VERSION_GREATER_EQUAL 6.0)
    target_link_libraries(drumstick-file PRIVATE
        Qt6::Core5Compat
    )
endif()


if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-file PROPERTIES
        STATIC_LIB "libdrumstick-file")
else()
    set_target_properties(drumstick-file PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        MACOSX_RPATH TRUE
        EXPORT_NAME File
    )
    if(BUILD_FRAMEWORKS)
        set_target_properties(drumstick-file PROPERTIES
            FRAMEWORK ${BUILD_FRAMEWORKS}
            FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            MACOSX_FRAMEWORK_IDENTIFIER "net.sourceforge.drumstick-file"
            MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake_admin/CustomFrameworkInfo.plist.in"
        )
    endif()
endif()

install(TARGETS drumstick-file
    EXPORT drumstick-file-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-file_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-file-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-file-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-file-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/drumstick-file-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-file-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-file-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-file-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-file-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== library/rt-backends/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(DRUMSTICK_PLUGINS_DIR "drumstick2")

if(FALSE)
    add_subdirectory(dummy-in)
    add_subdirectory(dummy-out)
endif()

if(ALSA_FOUND)
    add_subdirectory(alsa-in)
    add_subdirectory(alsa-out)
endif()

if (PULSE_FOUND)
    add_subdirectory(eassynth)
endif()

if(Qt${QT_VERSION_MAJOR}Network_FOUND)
    add_subdirectory(net-in)
    add_subdirectory(net-out)
endif()

if(UNIX AND NOT APPLE)
    add_subdirectory(oss-in)
    add_subdirectory(oss-out)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    add_subdirectory(mac-in)
    add_subdirectory(mac-out)
    add_subdirectory(macsynth)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    add_subdirectory(win-in)
    add_subdirectory(win-out)
endif()

if(FLUIDSYNTH_FOUND)
    add_subdirectory(fluidsynth)
endif()

=== library/rt/CMakeLists.txt ===
# MIDI Sequencer C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(drumstick-rt_QOBJ_SRCS
    ../include/drumstick/rtmidiinput.h
    ../include/drumstick/rtmidioutput.h
)

set(drumstick-rt_HEADERS
    ../include/drumstick/macros.h
    ../include/drumstick/rtmidiinput.h
    ../include/drumstick/rtmidioutput.h
    ../include/drumstick/backendmanager.h
)

if(BUILD_FRAMEWORKS)
    set_source_files_properties(${drumstick-rt_HEADERS}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/drumstick
    )
endif()

set(drumstick-rt_SRCS
    backendmanager.cpp
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_cpp(drumstick-rt_MOC_SRCS ${drumstick-rt_QOBJ_SRCS})
else()
    qt_wrap_cpp(drumstick-rt_MOC_SRCS ${drumstick-rt_QOBJ_SRCS})
endif()

add_library(drumstick-rt
    ${drumstick-rt_MOC_SRCS}
    ${drumstick-rt_SRCS}
    ${drumstick-rt_HEADERS}
)

add_library(Drumstick::RT ALIAS drumstick-rt)

target_include_directories(drumstick-rt PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_compile_definitions(drumstick-rt
    PRIVATE LIBSUFFIX=${CMAKE_INSTALL_LIBDIR}
)

target_link_libraries(drumstick-rt PRIVATE
    Qt${QT_VERSION_MAJOR}::Core
)

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-rt PROPERTIES
        STATIC_LIB "libdrumstick-rt")
else() # STATIC_DRUMSTICK
    set_target_properties(drumstick-rt PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME RT
      # macOS:
        MACOSX_RPATH TRUE
    )
    if (BUILD_FRAMEWORKS)
        set_target_properties(drumstick-rt PROPERTIES
            FRAMEWORK ${BUILD_FRAMEWORKS}
            FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            MACOSX_FRAMEWORK_IDENTIFIER "net.sourceforge.drumstick-rt"
            MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake_admin/CustomFrameworkInfo.plist.in"
        )
    endif()
endif() # STATIC_DRUMSTICK

install(TARGETS drumstick-rt
    EXPORT drumstick-rt-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-rt_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-rt-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-rt-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-rt-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/drumstick-rt-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-rt-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-rt-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-rt-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-rt-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== library/vpiano-plugin/CMakeLists.txt ===
# Drumstick PianoKeybd Qt Designer Plugin
# Copyright (C) 2008-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}UiPlugin REQUIRED)

set(SOURCES
    vpiano-plugin.h
    vpiano-plugin.cpp
    vpiano-plugin.qrc)

add_library(drumstick-vpiano-plugin MODULE ${SOURCES})

target_compile_definitions(drumstick-vpiano-plugin PRIVATE QT_PLUGIN)

target_include_directories(drumstick-vpiano-plugin PRIVATE
    ${Drumstick_SOURCE_DIR}/library/include
)

target_link_libraries(drumstick-vpiano-plugin PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::UiPlugin
    Drumstick::Widgets
)

set_target_properties(drumstick-vpiano-plugin PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib/designer)

get_target_property(QT_QMAKE_EXECUTABLE Qt${QT_VERSION_MAJOR}::qmake LOCATION)
execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
  OUTPUT_VARIABLE QT_INSTALL_PLUGINS OUTPUT_STRIP_TRAILING_WHITESPACE
)
execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_HOST_PREFIX
  OUTPUT_VARIABLE QT_HOST_PREFIX OUTPUT_STRIP_TRAILING_WHITESPACE
)
string(REPLACE "${QT_HOST_PREFIX}/" "" _INSTALL_PLUGINS  "${QT_INSTALL_PLUGINS}")

install(TARGETS drumstick-vpiano-plugin
    EXPORT drumstick-vpiano-targets
    RUNTIME DESTINATION ${_INSTALL_PLUGINS}/designer
    ARCHIVE DESTINATION ${_INSTALL_PLUGINS}/designer
    LIBRARY DESTINATION ${_INSTALL_PLUGINS}/designer)

=== library/widgets/CMakeLists.txt ===
# Drumstick Widgets C++ Library
# Copyright (C) 2005-2021 Pedro Lopez-Cabanillas <plcl@users.sourceforge.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}Network REQUIRED)
find_package(Qt${QT_VERSION_MAJOR}LinguistTools REQUIRED)

set(drumstick-widgets_HEADERS
    ../include/drumstick/pianokeybd.h
    ../include/drumstick/pianopalette.h
    ../include/drumstick/settingsfactory.h
    ../include/drumstick/configurationdialogs.h
)

set(drumstick-widgets_OBJ_SRCS
    ../include/drumstick/pianokeybd.h
    ../include/drumstick/pianopalette.h
    ../include/drumstick/rtmidiinput.h
    ../include/drumstick/rtmidioutput.h
    pianoscene.h
    fluidsettingsdialog.h
    networksettingsdialog.h
    macsynthsettingsdialog.h
    sonivoxsettingsdialog.h
)

if(BUILD_FRAMEWORKS)
    set_source_files_properties(${drumstick-widgets_HEADERS}
        PROPERTIES MACOSX_PACKAGE_LOCATION Headers/drumstick
    )
endif()

set(drumstick-widgets_SRCS
    configurationdialogs.cpp
    fluidsettingsdialog.cpp
    fluidsettingsdialog.h
    keylabel.cpp
    keylabel.h
    macsynthsettingsdialog.cpp
    macsynthsettingsdialog.h
    networksettingsdialog.cpp
    networksettingsdialog.h
    pianokey.cpp
    pianokey.h
    pianokeybd.cpp
    pianopalette.cpp
    pianoscene.cpp
    pianoscene.h
    settingsfactory.cpp
    sonivoxsettingsdialog.cpp
    sonivoxsettingsdialog.h
)

set(drumstick-widgets_FORMS
    fluidsettingsdialog.ui
    macsynthsettingsdialog.ui
    networksettingsdialog.ui
    sonivoxsettingsdialog.ui
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_wrap_ui(drumstick-widgets_UI_SRCS ${drumstick-widgets_FORMS})
    qt5_wrap_cpp(drumstick-widgets_MOC_SRCS ${drumstick-widgets_OBJ_SRCS})
    qt5_add_resources(drumstick-widgets_RESOURCES pianokeybd.qrc)
else()
    qt_wrap_ui(drumstick-widgets_UI_SRCS ${drumstick-widgets_FORMS})
    qt_wrap_cpp(drumstick-widgets_MOC_SRCS ${drumstick-widgets_OBJ_SRCS})
    qt_add_resources(drumstick-widgets_RESOURCES pianokeybd.qrc)
endif()

add_library(drumstick-widgets
    ${drumstick-widgets_UI_SRCS}
    ${drumstick-widgets_MOC_SRCS}
    ${drumstick-widgets_SRCS}
    ${drumstick-widgets_RESOURCES}
    ${drumstick-widgets_HEADERS}
)

add_library(Drumstick::Widgets ALIAS drumstick-widgets)

target_include_directories(drumstick-widgets PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

target_link_libraries(drumstick-widgets PRIVATE
    Qt${QT_VERSION_MAJOR}::Widgets
    Qt${QT_VERSION_MAJOR}::Network
    Drumstick::RT
)

set(TS_FILES
    translations/drumstick-widgets_cs.ts
    translations/drumstick-widgets_de.ts
    translations/drumstick-widgets_en.ts
    translations/drumstick-widgets_es.ts
    translations/drumstick-widgets_fr.ts
    translations/drumstick-widgets_gl.ts
    translations/drumstick-widgets_nl.ts
    translations/drumstick-widgets_ru.ts
    translations/drumstick-widgets_sr.ts
    translations/drumstick-widgets_sv.ts
    translations/drumstick-widgets_tr.ts
    translations/drumstick-widgets_zh_CN.ts
)

if (QT_VERSION VERSION_LESS 5.15.0)
    qt5_add_translation(QM_FILES ${TS_FILES})
else()
    qt_add_translation(QM_FILES ${TS_FILES})
endif()

add_custom_target(drumstick-widgets-translations ALL DEPENDS ${QM_FILES})

if (UNIX AND NOT APPLE)
    install( FILES ${QM_FILES}
             DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/drumstick )
endif ()

if(STATIC_DRUMSTICK)
    set_target_properties(drumstick-widgets PROPERTIES
        STATIC_LIB "libdrumstick-widgets")
else() # STATIC_DRUMSTICK
    set_target_properties(drumstick-widgets PROPERTIES
        VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
        SOVERSION ${PROJECT_VERSION_MAJOR}
        EXPORT_NAME Widgets
      # macOS:
        MACOSX_RPATH TRUE
    )
    if (BUILD_FRAMEWORKS)
        set_target_properties(drumstick-widgets PROPERTIES
            FRAMEWORK ${BUILD_FRAMEWORKS}
            FRAMEWORK_VERSION ${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}
            MACOSX_FRAMEWORK_IDENTIFIER "net.sourceforge.drumstick-widgets"
            MACOSX_FRAMEWORK_INFO_PLIST "${CMAKE_SOURCE_DIR}/cmake_admin/CustomFrameworkInfo.plist.in"
        )
    endif()
endif() # STATIC_DRUMSTICK

install(TARGETS drumstick-widgets
    EXPORT drumstick-widgets-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    FRAMEWORK DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${drumstick-widgets_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/drumstick)

install(EXPORT drumstick-widgets-targets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
    NAMESPACE Drumstick::
)

export(EXPORT drumstick-widgets-targets
    NAMESPACE Drumstick::
    FILE ${CMAKE_BINARY_DIR}/drumstick-widgets-targets.cmake
)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_BINARY_DIR}/drumstick-widgets-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

configure_file( drumstick-widgets-config.cmake
  ${CMAKE_BINARY_DIR}/drumstick-widgets-config.cmake
  @ONLY
)

install(FILES
    ${CMAKE_BINARY_DIR}/drumstick-widgets-config-version.cmake
    ${CMAKE_BINARY_DIR}/drumstick-widgets-config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/drumstick
)

=== debian/changelog ===
drumstick-dmo (1:2.3.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 29 Jul 2021 19:46:09 +0200

drumstick-dmo (1:2.3.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 29 Jun 2021 07:30:47 +0200

drumstick-dmo (1:2.2.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 01 Jun 2021 02:16:33 +0200

drumstick-dmo (1:2.2.0-dmo2) unstable; urgency=medium

  * libdrumstick-dev should Depends on libdrumstick-rt-backends

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 12 May 2021 23:46:02 +0200

drumstick-dmo (1:2.2.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 10 May 2021 08:49:48 +0200

drumstick-dmo (1:2.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 31 Mar 2021 08:41:00 +0200

drumstick-dmo (1:2.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 21 Mar 2021 10:15:24 +0100

drumstick-dmo (1:2.0.0-dmo2) unstable; urgency=medium

  * Enable D-Bus support.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 18 Jan 2021 15:17:58 +0100

drumstick-dmo (1:2.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 30 Dec 2020 09:24:21 +0100

drumstick-dmo (1:1.1.3-dmo4) unstable; urgency=medium

  * Fix build with libfluidsynth2

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 16 Dec 2019 08:24:16 +0100

drumstick-dmo (1:1.1.3-dmo3) unstable; urgency=medium

  * Build with libfluidsynth2

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 15 Dec 2019 01:59:08 +0100

drumstick-dmo (1:1.1.3-dmo2) unstable; urgency=medium

  * Build against qtbase-abi-5-12-5 and/or qtdeclarative-abi-5-12-5.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 23 Oct 2019 09:52:28 +0200

drumstick-dmo (1:1.1.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 02 Sep 2019 15:02:40 +0200

drumstick-dmo (1:1.1.2-dmo4) unstable; urgency=medium

  * Restore symlinks to /usr/lib/drumstick for libdrumstick-rt-backends
    package. cmake does not do what is supposed to do.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 23 Aug 2019 17:39:49 +0200

drumstick-dmo (1:1.1.2-dmo3) unstable; urgency=medium

  * Split shared library package to match SONAMEs.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Aug 2019 19:24:09 +0200

drumstick-dmo (1:1.1.2-dmo2) unstable; urgency=medium

  * Add a symlink /usr/lib/drumstick --> to
    /usr/lib/$(DEB_HOST_MULTIARCH)/drumstick

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 26 Nov 2018 13:31:17 +0100

drumstick-dmo (1:1.1.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 26 Nov 2018 08:31:27 +0100

drumstick-dmo (1:1.1.1-dmo2) unstable; urgency=medium

  * Move plugins to /usr/lib

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 10 Oct 2018 19:43:11 +0200

drumstick-dmo (1:1.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 26 Feb 2018 08:50:34 +0100

drumstick-dmo (1:1.1.0-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 08 Mar 2017 08:43:46 +0100

=== debian/control ===
Source: drumstick-dmo
Section: libs
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: http://drumstick.sourceforge.net/
Standards-Version: 4.5.1
Build-depends-Indep: doxygen, docbook-xml, docbook-xsl, graphviz
Build-Depends: debhelper-compat (= 13), cmake, libasound2-dev, libqt5svg5-dev,
 xsltproc, qtbase5-dev, libx11-dev, pkg-config, libfluidsynth-dev, libpulse-dev,
 shared-mime-info, ninja-build, qttools5-dev

Package: libdrumstick-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libdrumstick-alsa2 (= ${binary:Version}), libdrumstick-file2 (= ${binary:Version}),
 libdrumstick-rt2 (= ${binary:Version}), libdrumstick-widgets2 (= ${binary:Version}),
 libdrumstick-rt-backends (= ${binary:Version}), ${misc:Depends} 
Replaces: libdrumstick1
Conflicts: libdrumstick1
Description: Qt5/C++ wrapper for ALSA Sequencer - development files
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for SMF and WRK
 file processing are also included.
 .
 This package provides the development files.

Package: libdrumstick-alsa2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libdrumstick1
Conflicts: libdrumstick1
Description: Qt5/C++ wrapper for ALSA Sequencer (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for OVE and WRK
 file processing are also included.
 .
 This package provides the shared library.

Package: libdrumstick-file2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libdrumstick1
Conflicts: libdrumstick1
Description: File format support library for drumstick (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for OVE and WRK
 file processing are also included.
 .
 This package contains the shared library for support of MIDI, Cakewalk and
 Overture file formats.

Package: libdrumstick-rt2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libdrumstick-rt-backends (= ${binary:Version}), rtkit
Replaces: libdrumstick1
Conflicts: libdrumstick1
Description: Realtime MIDI I/O with pluggable backends (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for OVE and WRK
 file processing are also included.
 .
 This package contains the shared library for realtime MIDI I/O with plugin
 support.

Package: libdrumstick-widgets2
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Realtime MIDI I/O with pluggable backends (shared library)
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for OVE and WRK
 file processing are also included.
 .
 This package contains the shared library for libdrumstick widgets.

Package: libdrumstick-rt-backends
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libdrumstick1
Conflicts: libdrumstick1
Description: Realtime MIDI I/O backends
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for OVE and WRK
 file processing are also included.
 .
 This package contains the bakcends for realtime MIDI I/O.

Package: drumstick-tools
Section: sound
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Qt5/C++ wrapper for ALSA Sequencer - utilities
 This library is a C++ wrapper around the ALSA library sequencer interface,
 using Qt5 objects, idioms and style. ALSA sequencer provides software
 support for MIDI technology on Linux. Complementary classes for SMF and WRK
 file processing are also included.
 .
 This package provides utilities shipped with the library:
  - drumstick-buildsmf: Standard MIDI File creation from scratch.
  - drumstick-dumpgrid: Simple Qt drum sequencer.
  - drumstick-dumpmid: Write ALSA MIDI events to STDOUT.
  - drumstick-dumpsmf: Write MIDI events from a MIDI file to STDOUT.
  - drumstick-dumpwrk: Write MIDI events from a Cakewalk WRK file to STDOUT.
  - drumstick-guiplayer: Simple Qt MIDI file player.
  - drumstick-metronome: Headless MIDI metronome.
  - drumstick-playsmf: Headless MIDI file player.
  - drumstick-sysinfo: Display information about ALSA MIDI.
  - drumstick-timertest: Test performance of the ALSA timer.
  - drumstick-vpiano: Virtual Piano Keyboard GUI application.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release -DUSE_DBUS=YES

override_dh_auto_test:
	if -f /dev/snd/deq ; then dh_auto_test ; fi
